#include <iostream>
#include <vector>
#include <algorithm>
#include <cmath>
#include <set>

#define int long long

using namespace std;

vector < int > l, r, pred, sz;

int find_set(int u)
{
    if(u == pred[u])
        return u;
    return pred[u] = find_set(pred[u]);
}

void unite(int u, int v)
{
    u = find_set(u);
    v = find_set(v);
    if(u == v)
        return;
    if(sz[u] > sz[v])
        swap(u, v);
    pred[u] = v;
    sz[v] += sz[u];
    return;
}

main()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    int n, m;
    cin >> n >> m;
    l.resize(m);
    r.resize(m);
    for(int i = 0; i < m; i++)
    {
        cin >> l[i] >> r[i];
        l[i]--;
        r[i]--;
    }
    int ans = 0;
    for(int i = 0; i < m; i++)
    {
        pred.clear();
        pred.resize(n);
        for(int j = 0; j < n; j++)
            pred[j] = j;
        sz.clear();
        sz.resize(n, 1);
        for(int j = 0; j < m; j++)
        {
            if(i == j)
                continue;
            unite(l[j], r[j]);
        }
//        for(int j=0;j<n;j++)
//            cout<<pred[j]<<" ";
        if(pred[find_set(l[i])] != pred[find_set(r[i])])
            ans++;
//            cout<<'\n';
    }
    cout << ans;
    return 0;
}
