#include <fstream>
#include <iostream>
#include <vector>
#include <set>
#include <list> 
#include <map>
#include <queue>
#include <deque>
#include <string>
#include <stack>
#include <algorithm>
#include <utility>
#include <math.h>
#include <ctime>

using namespace std;
typedef long long int63;
typedef unsigned long long int64;
#define forl(name,start,end,jump) for(int63 name = start; name < end; name+=jump)
#define forlb(name,start,end,jump) for(int63 name = end - 1; name >= start; name+=jump)
#define forn(name,start,end) forl(name,start,end,1)
#define fornb(name,start,end) forlb(name,start,end,-1)
#define fort(start,end) forn(i,start,end)
#define fortb(start,end) fornb(i,start,end)
#define forto(start,end) forn(j,start,end)
#define fortob(start,end) fornb(j,start,end)
#define fortoo(start,end) forn(l,start,end)
#define make(name) int63 name; cin >> name
#define all(name) name.begin(), name.end()
#define rall(name) name.rbegin(), name.rend()
#define point pair<int63,int63>
#define dpoint pair<double,double>

union superdat {
	int63 i;
	double d;
	vector<int63>vi;
	queue<int63>q;
	vector<point>vp;
	point p;
};

struct union_find {
	vector<int63>rot;
	vector<vector<int63>> rat;
	int63 cnt;
	void init(int63 n) {
		fort(0, n) {
			rot.push_back(i);
			rat.push_back({i});
		}
		cnt = n;
	}
	bool isunion(int63 f, int63 s) {
		if (rot[f] == rot[s]) {
			return true;
		}
		return false;
	}
	bool unio(int63 f, int63 s) {
		if (rot[f] == rot[s]) {
			return false;
		}
		cnt--;
		//rot[f] <-> rot[s]
		if (rat[rot[f]].size() < rat[rot[s]].size()) {
			swap(f, s);
		}
		int63 siz = rat[rot[s]].size();
		int63 rs = rot[s];
		fort(0, siz) {
			rat[rot[f]].push_back(rat[rs][i]);
			rot[rat[rs][i]] = rot[f];
		}
		rat[rs].clear();
		return true;
	}
};

int main() {
	ios::sync_with_stdio(false);
	cin.tie(0);
	cout.tie(0);
	make(n);
	make(m);
	vector<point>cons(m);
	fort(0, m) {
		cin >> cons[i].first >> cons[i].second;
		cons[i].first--;
		cons[i].second--;
	}
	vector<union_find> v(m);
	union_find vv;
	vv.init(n);
	forto(0, m) {
		vv.unio(cons[j].first, cons[j].second);
	}
	int63 ans = 0;
	fort(0, m) {
		v[i].init(n);
		forto(0, m) {
			if (i == j) {
				continue;
			}
			v[i].unio(cons[j].first, cons[j].second);
		}
		if (v[i].cnt > vv.cnt) {
			ans++;
		}
	}
	cout << ans << endl;
	return 0;
}