#include <iostream>
#include <vector>

//#define DFSDEBUG
//#define CHECKDEBUG

using namespace std;

class node{
public:
    int e;
    bool traversed;
    bool checked;
    vector<int> c;
};

class Pair{
public:
    Pair(int i1, int i2){
        a = i1;
        b = i2;
    }
    Pair(){};
    int a, b;
};

int dfs(int start, int last, vector<node>& graph){
#ifdef DFSDEBUG
    cout << "start = " << start << ", last = " << last << ";\n";
#endif // DFSDEBUG
    if(graph[start].traversed){
#ifdef DFSDEBUG
        cout << "start = " << start << ", returned " << graph[start].e << ";\n";
#endif // DFSDEBUG
        return graph[start].e;
    }
    graph[start].traversed = true;
    int res;
    for(int i = 0; i < graph[start].c.size(); ++i){
        if(graph[start].c[i] != last){
            res = dfs(graph[start].c[i], start, graph);
            if(res != -1 && graph[start].e != res){
#ifdef DFSDEBUG
                cout << "graph[" << start << "] = " << res << ";\n";
#endif // DFSDEBUG
                graph[graph[start].e].e = res;
                graph[start].e = res;
            }
        }
    }
    if(graph[start].e == start){
#ifdef DFSDEBUG
        cout << "start = " << start << ", returned -1;\n";
#endif // DFSDEBUG
        return -1;
    }
#ifdef DFSDEBUG
    cout << "start = " << start << ", returned " << graph[start].e << ";\n";
#endif // DFSDEBUG
    return graph[start].e;
}

void check(int n, vector<node>& graph){
    if(graph[n].e == n){
        graph[n].checked = true;
        return;
    }
    if(!graph[graph[n].e].checked){
        check(graph[n].e, graph);
    }
    graph[n].e = graph[graph[n].e].e;
    graph[n].checked = true;
}

int main()
{
    cin.tie(NULL);
    int n, m;
    cin >> n >> m;
    vector<Pair> connections(m, Pair());
    int a, b;
    vector<node> vec(n);
    for(int i = 0; i < n; ++i){
        vec[i].e = i;
        vec[i].traversed = false;
        vec[i].checked = false;
    }
    for(int i = 0; i < m; ++i){
        cin >> a >> b;
        --a;
        --b;
        vec[a].c.push_back(b);
        vec[b].c.push_back(a);
        connections[i] = Pair(a, b);
    }
    dfs(0, -1, vec);
#ifdef DFSDEBUG
    for(int i = 0; i < n; ++i){
        cout << "node " << i << " # node " << vec[i].e << ";\n";
    }
#endif // DFSDEBUG
    for(int i = 0; i < n; ++i){
        check(i, vec);
    }
#ifdef CHECKDEBUG
    for(int i = 0; i < n; ++i){
        cout << "node " << i << " # node " << vec[i].e << ";\n";
    }
#endif // CHECKDEBUG
    int res = 0;
    for(int i = 0; i < m; ++i){
        if(vec[connections[i].a].e != vec[connections[i].b].e){
            ++res;
        }
    }
    cout << res << endl;
    return 0;
}

/*
10 13
1 2
2 3
3 1
3 4
4 5
5 6
6 7
7 4
6 4
7 9
9 8
9 10
10 8
*/
