#include <iostream>
#include <vector>
#define endl '\n'
using namespace std;

const int MAXN = 600;

int t = 0, cnt = 0;
bool used[MAXN + 5];
vector<int> G[MAXN + 5];
int found[MAXN + 5], low[MAXN + 5], parent[MAXN + 5];

void DFS(int u)
{
    used[u] = true;
    found[u] = low[u] = t;
    t++;
    for (int i = 0; i < G[u].size(); ++ i)
    {
        int v = G[u][i];
        if (!used[v])
        {
            parent[v] = u;
            DFS(v);
            low[u] = min(low[u], low[v]);
            
            if (found[u] < low[v]) cnt++;
        }
        else if (v != parent[u])
        {
            low[u] = min(low[u], found[v]);
        }
    }
}

int main()
{
    ios :: sync_with_stdio(false);
    cin.tie(NULL); cout.tie(NULL);
    
    int n, m;
    cin >> n >> m;
    
    for (int i = 0; i < m; ++ i)
    {
        int u, v;
        cin >> u >> v;
        G[u].push_back(v);
        G[v].push_back(u);
    }
    
    for (int i = 1; i <= n; ++ i)
    {
        parent[i] = -1;
    }
    
    for (int i = 1; i <= n; ++ i)
    {
        if (!used[i]) DFS(i);
    }
    
    cout << cnt << endl;
    
    return 0;
}
